/**
 * @file ControlThread.cpp
 * @date 2010/02/20 新規作成
 * @author
 *
 * Thread制御クラス
 */
#include "Define.h"
#include "ControlThread.h"

/**
 * デフォルトコンストラクタ
 */
ControlThread::ControlThread(){
}

/**
 * スレッドの開始
 * @param routine スレッドの関数ポインタ
 * @param argument スレッドの引数ポインタ
 * @return 処理結果 OK/NG
 */
ReturnValue ControlThread::begin(void *(*routine)(void *), void *argument){
	if( pthread_create(&m_ThreadID, NULL, routine,	argument) != 0 )
	{
		return NG;
	}
	return OK;
}

/**
 * スレッドの終了待ち
 * @return 処理結果 OK/NG
 */
int ControlThread::waitForCompletion(){
	void *returnValue = NULL;

	if( pthread_join(m_ThreadID, &returnValue) != 0 )
	{
		return -1;
	}
	return *(int*)returnValue;
}
