/**
 * @file GetProfile.cpp
 * @date 2010/04/10 新規作成
 * @author
 *
 * INIファイルパラメータ取得クラス
 */
#include <sstream>
#include "Define.h"
#include "GetProfile.h"

/**
 * コンストラクタ
 */
GetProfile::GetProfile(std::string path){
	m_Filename = path;
}

/**
 * int型value値取得
 * @param section セクション名
 * @param name 値名
* @return value値(int)
 */
int GetProfile::getInt(std::string section, std::string name){
	int value = 0;
	m_IniFile = m_ReadIniFile.read(m_Filename);
	for(std::string::size_type i = 0; i < m_IniFile.getData().size(); i++){
		if( m_IniFile.getData().at(i).sectionName.compare(section.c_str()) == 0 ){
			for(std::string::size_type j = 0; j < m_IniFile.getData().at(i).parameter.size(); j++){
				if( m_IniFile.getData().at(i).parameter.at(j).name.compare(name.c_str()) == 0 ){
					std::istringstream buffer(m_IniFile.getData().at(i).parameter.at(j).value);
					buffer >> std::dec >> value;
				}
			}
		}
	}
	return value;
}



/**
 * std::string型value値取得
 * @param section セクション名
 * @param name 値名
 * @return value値(std::string)
 */
std::string& GetProfile::getString(std::string section, std::string name){
	m_IniFile = m_ReadIniFile.read(m_Filename);
	m_BufferString = "";
	for(std::string::size_type i = 0; i < m_IniFile.getData().size(); i++){
		if( m_IniFile.getData().at(i).sectionName.compare(section.c_str()) == 0 ){
			for(std::string::size_type j = 0; j < m_IniFile.getData().at(i).parameter.size(); j++){
				if( m_IniFile.getData().at(i).parameter.at(j).name.compare(name.c_str()) == 0 ){
					m_BufferString = m_IniFile.getData().at(i).parameter.at(j).value;
				}
			}
		}
	}
	return m_BufferString;
}

