/**
 * @file Test6.cpp
 * @date 2010/04/11 新規作成
 * @author
 *
 * Test6クラス
 */

#include <assert.h>
#include <fstream>
#include <iostream>
#include <cstdio>
#include "Define.h"
#include "WriteProfile.h"
#include "GetProfile.h"
#include "Test6.h"

/**
 * コンストラクタ
 */
Test6::Test6(){
}

ReturnValue Test6::copyFile(std::string original, std::string destination)
{
	std::ifstream input(original.c_str());
	std::ofstream output(destination.c_str());
	char buffer[256];
	std::string string_buffer;
	if( input != false ){
		while( input.eof() != true ){
			input.getline(buffer, sizeof(buffer));
			string_buffer = buffer;
			string_buffer += '\n';
			output.write(string_buffer.c_str(), string_buffer.length());
		}
		input.close();
		output.close();
	}
	return OK;
}

/**
 * test関数
 */
ReturnValue Test6::run()
{
	test1();
	test2();
	test3();
	std::cout << "Test6 finished" << std::endl;
	return OK;
}

ReturnValue Test6::test1()
{
	copyFile("1.ini", "Test6_test1.ini");
	WriteProfile write_profile("Test6_test1.ini");
	write_profile.writeInt("display_number", "current", 2);
	GetProfile	get_profile("Test6_test1.ini");
	assert(get_profile.getInt("display_number", "current") == 2);
	remove("Test6_test1.ini");
	return OK;
}

ReturnValue Test6::test2()
{
	copyFile("1.ini", "Test6_test2.ini");
	WriteProfile write_profile("Test6_test2.ini");
	write_profile.writeString("setting_3", "name", "abcdefg");
	GetProfile	get_profile("Test6_test2.ini");
	assert(get_profile.getString("setting_3", "name").compare("abcdefg") == 0);
	remove("Test6_test2.ini");
	return OK;
}

ReturnValue Test6::test3()
{
	copyFile("1.ini", "Test6_test3.ini");
	WriteProfile write_profile("Test6_test3.ini");
	write_profile.writeString("setting_4", "name", "あいうえお");
	GetProfile	get_profile("Test6_test3.ini");
	assert(get_profile.getString("setting_4", "name").compare("あいうえお") == 0);
	remove("Test6_test3.ini");
	return OK;
}

